package joptionpanel;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.BorderFactory;
import java.awt.BorderLayout;
import javax.swing.border.Border;
import javax.swing.border.BevelBorder;
import java.awt.Dimension;
import java.awt.Color;
import fwpUtil.*;
import javax.swing.text.AttributeSet;

/**
 * <p>Title: J Option Panel Demo</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: </p>
 *
 * @author Fred Pospeschil
 * @version 1.0
 */
public class OptionFrame extends JFrame {
  JPanel       contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar     jMenuBar1 = new JMenuBar();
  JMenu        jMenuFile = new JMenu();
  JMenuItem    jMenuFileExit = new JMenuItem();
  JToolBar     jToolBar = new JToolBar();
  JButton      jButton1 = new JButton();
  JButton      jButton2 = new JButton();
  JButton      jButton3 = new JButton();
  JLabel       statusBar = new JLabel();
  JMenu        Comfirm = new JMenu();
  JMenu        Input = new JMenu();
  JMenu        Message = new JMenu();
  JMenu        Option = new JMenu();
  JMenuItem    ConfirmDefault = new JMenuItem();
  JMenuItem    ConfirmYesNo = new JMenuItem();
  JMenuItem    ConfirmYesNoStacked = new JMenuItem();
  JMenuItem    InputSimpleInput = new JMenuItem();
  JMenuItem    InputSelectString = new JMenuItem();
  JMenuItem    OptionDialog = new JMenuItem();
  JMenuItem    SimpleMessage = new JMenuItem();
  JMenuItem    MessageWithTitleIcon = new JMenuItem();
  Border       border1 = BorderFactory.createLineBorder(Color.white, 2);
  JButton      LineAndColor = new JButton();
  JButton      LogIt = new JButton();
  JPanel       jPanelCenter = new JPanelCenter();

  public OptionFrame() {
    try {
      setDefaultCloseOperation(EXIT_ON_CLOSE);
      jbInit();
    }
    catch (Exception exception) {
      exception.printStackTrace();
    }
  }

  /**
   * Component initialization.
   *
   * @throws java.lang.Exception
   */
  private void jbInit() throws Exception {
    border1 = BorderFactory.createBevelBorder(BevelBorder.RAISED,
                                              Color.white, Color.white,
                                              new Color(103, 101, 98),
                                              new Color(148, 145, 140));
    contentPane = (JPanel) getContentPane();
    contentPane.setLayout(borderLayout1);
    setSize(new Dimension(465, 445));
    setTitle("J OPtion Pane and Choosers   Demo");
    statusBar.setBorder(BorderFactory.createLoweredBevelBorder());
    statusBar.setText(" Status Bar");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent actionEvent) {
        jMenuFileExit_actionPerformed(actionEvent);
      }
    });

    Comfirm.setText("Confirm");
    Input.setText("Input");
    Message.setText("Message");
    Option.setText("Option");
    ConfirmDefault.setText("Default & Plain Message");
    ConfirmDefault.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ConfirmDefault_actionPerformed(e);
      }
    });
    ConfirmYesNo.setText("Yes/No ? Message");
    ConfirmYesNo.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ConfirmYesNo_actionPerformed(e);
      }
    });
    ConfirmYesNoStacked.setText("Yes/No Stacked Messages");
    ConfirmYesNoStacked.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ConfirmYesNoStacked_actionPerformed(e);
      }
    });
    InputSimpleInput.setText("Simple Input");
    InputSimpleInput.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        InputSimpleInput_actionPerformed(e);
      }
    });
    InputSelectString.setText("Select a String");
    InputSelectString.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        InputSelectString_actionPerformed(e);
      }
    });
    OptionDialog.setText("Option Dialog");
    OptionDialog.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        OptionDialog_actionPerformed(e);
      }
    });
    SimpleMessage.setText("Simple Message");
    SimpleMessage.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        SimpleMessage_actionPerformed(e);
      }
    });
    MessageWithTitleIcon.setText("Message With Title & Icon");
    MessageWithTitleIcon.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        MessageWithTitleIcon_actionPerformed(e);
      }
    });
    jToolBar.setBorder(BorderFactory.createLoweredBevelBorder());
    contentPane.setBorder(null);
    jButton2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    LineAndColor.setToolTipText("Help");
    LineAndColor.setText("Line & Color");
    LineAndColor.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        LineAndColor_actionPerformed(e);
      }
    });
    jButton3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton3_actionPerformed(e);
      }
    });
    jButton1.setText("Font");
    jButton2.setText("Font & Color");
    jButton3.setText("Color");
    LogIt.setText("LogIt");
    LogIt.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        LogIt_actionPerformed(e);
      }
    });
    jMenuBar1.add(jMenuFile);
    jMenuFile.add(jMenuFileExit);
    jMenuBar1.add(Comfirm);
    jMenuBar1.add(Input);
    jMenuBar1.add(Message);
    jMenuBar1.add(Option);
    setJMenuBar(jMenuBar1);
    jButton1.setToolTipText("Open File");
    jButton2.setToolTipText("");
    jButton3.setToolTipText("");
    jToolBar.add(LineAndColor);
    jToolBar.add(jButton1);
    jToolBar.add(jButton2);
    jToolBar.add(jButton3);
    jToolBar.add(LogIt);
    contentPane.add(jPanelCenter, java.awt.BorderLayout.CENTER);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    Comfirm.add(ConfirmDefault);
    Comfirm.add(ConfirmYesNo);
    Comfirm.add(ConfirmYesNoStacked);
    Input.add(InputSimpleInput);
    Input.add(InputSelectString);
    Option.add(OptionDialog);
    Message.add(SimpleMessage);
    Message.add(MessageWithTitleIcon);
    contentPane.add(jToolBar, java.awt.BorderLayout.NORTH);
  };


    /**
     * File | Exit action performed.
     *
     * @param actionEvent ActionEvent
     */
    void jMenuFileExit_actionPerformed(ActionEvent actionEvent) {
      System.exit(0);
    }

  public void ConfirmDefault_actionPerformed(ActionEvent e)
   {
   int selection;
   selection = JOptionPane.showConfirmDialog(statusBar,
               "This is a plain plain message\n using the default option \n" +
               "and it controls the length of the message.",
               "This is the title of the J Option Panel.",
               // DEFAULT_OPTION, YES_NO_OPTION,
               //  YES_NO_CANCEL_OPTION, OK_CANCEL_OPTION
               JOptionPane.DEFAULT_OPTION, // shows only OK button
               // ERROR_MESSAGE, INFORMATION_MESSAGE,WARNING_MESSAGE,
               // QUESTION_MESSAGE, pLAIN_MESSAGE
               JOptionPane.PLAIN_MESSAGE);
   switch (selection)
     {
     case JOptionPane.CANCEL_OPTION:
       statusBar.setText("Cancel Option was Selected");
       break;
     case JOptionPane.YES_OPTION:
       statusBar.setText("Yes Option was Selected");
       break;
     case JOptionPane.NO_OPTION:
       statusBar.setText("No Option was Selected");
       break;
     }
   } // End ConfirmDefault_actionPerformed


  public void ConfirmYesNo_actionPerformed(ActionEvent e)
   {
   int selection;
   selection = JOptionPane.showConfirmDialog(statusBar,
               "Do you want to continue with this operation?.",
               "This is the title of the Yes-No J Option Panel.",
               // DEFAULT_OPTION, YES_NO_OPTION,
               //  YES_NO_CANCEL_OPTION, OK_CANCEL_OPTION
               JOptionPane.YES_NO_OPTION, // shows Yes No buttons
               // ERROR_MESSAGE, INFORMATION_MESSAGE,WARNING_MESSAGE,
               // QUESTION_MESSAGE, pLAIN_MESSAGE
               JOptionPane.QUESTION_MESSAGE);
   switch (selection)
     {
     case JOptionPane.YES_OPTION:
       statusBar.setText("Yes Option was Selected");
       break;
     case JOptionPane.NO_OPTION:
       statusBar.setText("No Option was Selected");
       break;
     }
   } // End ConfirmYesNo_actionPerformed


  public void ConfirmYesNoStacked_actionPerformed(ActionEvent e)
   {
   int selection;
   // The values object contains the messages to be shown stacked.
   Object[] messages = {"First value","Second value","Third value"};
   selection = JOptionPane.showConfirmDialog(contentPane,
               messages,
               "This is the title of the Yes-No J Option Panel.",
               // DEFAULT_OPTION, YES_NO_OPTION,
               //  YES_NO_CANCEL_OPTION, OK_CANCEL_OPTION
               JOptionPane.YES_NO_OPTION, // shows Yes No buttons
               // ERROR_MESSAGE, INFORMATION_MESSAGE,WARNING_MESSAGE,
               // QUESTION_MESSAGE, PLAIN_MESSAGE
               JOptionPane.QUESTION_MESSAGE);
   switch (selection)
     {
     case JOptionPane.YES_OPTION:
       statusBar.setText("Yes Option was Selected");
       break;
     case JOptionPane.NO_OPTION:
       statusBar.setText("No Option was Selected");
       break;
       }
   } // End ConfirmYesNoStacked_actionPerformed


  public void InputSimpleInput_actionPerformed(ActionEvent e)
   {
   String inputString = JOptionPane.showInputDialog("Please enter your answer.");
   if (inputString == null) inputString = " "; // Keeps status bar visable
   statusBar.setText(inputString);
   } // End InputSimpleInput_actionPerformed


  public void InputSelectString_actionPerformed(ActionEvent e)
   {
   Object[] possibleValues = {"First value", "Second value", "Third value",
                        "This is a long fourth value ====================",
                        "Now for a short fifth string"};
   Object selectedValue = JOptionPane.showInputDialog(contentPane,
       "Choose one", // Instruction to the user
       "Select a string from the drop down list", // Title for the input box
       JOptionPane.INFORMATION_MESSAGE, // Show the info icon
       null, // Don't show additional icon
       possibleValues, // Values to be shown in a drop down list
       possibleValues[1]); // Default value to be shown in list box
  // Prevent null pointer & keep the status bar visable
   if (selectedValue == null) selectedValue = " ";
   statusBar.setText(selectedValue.toString()); // Show selected value
   } // End InputSelectString_actionPerformed


  public void OptionDialog_actionPerformed(ActionEvent e)
   {
   Object[] messages = {"Line 1 of instructions.",
                        "Line 2 of instructions.",
                        "Line 3 of instructions.",
                        "Line 4 of instructions"};
   Object[] possibleValues = {"First value", "Second value", "Third value",
                        "This is a long fourth value ====================",
                        "Now for a short fifth string"};
   Object selectedValue = JOptionPane.showInputDialog(contentPane,
       messages, // Instruction to the user
       "Select a string from the drop down list", // Title for the input box
       JOptionPane.INFORMATION_MESSAGE, // Show the info icon
       null, // Don't show additional icon
       possibleValues, // Values to be shown in a drop down list
       possibleValues[1]); // Default value to be shown in list box
   // Prevent null pointer & keep the status bar visable
   if (selectedValue == null) selectedValue = " ";
   statusBar.setText(selectedValue.toString()); // Show selected value
   } // End OptionDialog_actionPerformed


  public void SimpleMessage_actionPerformed(ActionEvent e)
   {
   JOptionPane.showMessageDialog(contentPane,
               "This shows a simple info message" +
               "\n         plus the OK Button" +
               " \n   It does not return any values",
               "This is the title line",
               // ERROR_MESSAGE, INFORMATION_MESSAGE,WARNING_MESSAGE,
               // QUESTION_MESSAGE, PLAIN_MESSAGE
               JOptionPane.WARNING_MESSAGE);
   } // End SimpleMessage_actionPerformed


  public void MessageWithTitleIcon_actionPerformed(ActionEvent e)
   {
     JOptionPane.showMessageDialog(contentPane,"This shows a simple info message"
                                          + "\n         plus the OK Button"
                                          + "\n   It does not return any values");

   } // End MessageWithTitleIcon_actionPerformed

  public void jButton2_actionPerformed(ActionEvent e)
   {
   FontAndColorChooser fc = new FontAndColorChooser(this);
   Font font = fc.getNewFont();
    System.out.println("F&c -font1 = " + font);
   Color color = fc.getNewColor();
    System.out.println("F&C -color = " + color);
   AttributeSet atts = fc.getAttributes();
    System.out.println("F&C -Attributes = " + atts);
    System.out.println("F&C -toString = " + fc.toString());
    statusBar.setForeground(color);
    statusBar.setFont(font);
    statusBar.setText(fc.toString());
    fc.dispose();
  } // End jButton2_actionPerformed

  public void jButton1_actionPerformed(ActionEvent e)
    {
    final FontChooser dlg = new FontChooser(this);
    Font font = dlg.getNewFont();
    statusBar.setFont(font);
    statusBar.setText(font.toString());
    System.out.println("-font1     = " + font);
    dlg.dispose();
    }

  public void jButton3_actionPerformed(ActionEvent e)
    {
    // Create the color chooser
    ColorChooser fc = new ColorChooser(this);
    Color color = fc.getNewColor();
    int red   = color.getRed();
    int green = color.getGreen();
    int blue  = color.getBlue();
    int alpha = color.getAlpha();
    statusBar.setForeground(color);
    statusBar.setText(fc.toString());
    fc.dispose();
    }

  // Initialize the graphics context attributes so they can be used when
  // the display is initially shown.
  Color color = new Color(0,0,255,255);
  BasicStroke stroke = new
        BasicStroke(4,1,1,1,new float[]{14,14,14,14,28,14},0);
  RenderingHints hints = GetHints.getQualityRenderingHints();

   public class JPanelCenter extends JPanel
    {
    protected void paintComponent (Graphics g)
      {
      super.paintComponent(g); // Let the JPanel super class do its thing
      Graphics2D g2D = (Graphics2D)g.create();
      g2D.setColor(color);
      g2D.setStroke(stroke);
      g2D.setRenderingHints(hints);
      g2D.drawLine(0, 100, 450, 100);
      g2D.dispose();
      } // End paintComponent
    } // End class Islands

  public void LineAndColor_actionPerformed(ActionEvent e)
    {
    // Create a line and color chooser
    final LineAndColorChooser lc = new LineAndColorChooser(this);

    // Extract the color object
    color = lc.getNewColor();
    System.out.println("-OP Color="+color);

    // Extract the stroke object
    stroke = lc.getNewStroke();
    System.out.println("-OP stroke="+stroke);

    // Create a graphics 2D object
    Graphics2D g2D = (Graphics2D)contentPane.getGraphics();
    System.out.println("-OP g2D=" + g2D.toString());
    g2D.dispose();

    System.out.println(lc.toString());

    hints = lc.getRenderingHints();

    // Update the graphics 2D object
    lc.updateG2D(g2D);

    statusBar.setForeground(color);
    jPanelCenter.repaint();
    lc.dispose();
    } // End LineAndColor_actionPerformed


  public void LogIt_actionPerformed(ActionEvent e)
    {
    LogIt log = new LogIt(this);
    System.out.println("LotIt called =====================");
    System.out.println(log.toString());
    }


}// End of JFrame
