package joptionpanel;

import java.awt.Toolkit;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import java.awt.Dimension;
import fwpUtil.*;

/**
 * <p>Title: J Option Panel Demo</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: </p>
 *
 * @author Fred Poaspeschil
 * @version 1.0
 */
public class OptionPannels {
  boolean packFrame = false;

  /**
   * Construct and show the application.
   */
  public OptionPannels() {
  // Set up the logging process by getting the user's current
  // directory and adding a file seperator (\) to the end of the string.
  String logFilePath = System.getProperty("user.dir")
                     + System.getProperty("file.separator");
  // Designate a default name for the log file
  String logFileName = "Log.txt";
  // Start the logging capability
  String helpFileName = "LogItHelp.htm";
  // Start the logging capability.  Put log and help files in same directory.
  Logger.startLogger(logFilePath, logFileName, logFilePath, helpFileName);
  // Set the initial logging level
  Logger.setLogLevel(Logger.ALL);

  // All of the following code is JBuilder generated
  OptionFrame frame = new OptionFrame();
  // Validate frames that have preset sizes
  // Pack frames that have useful preferred size info, e.g. from their layout
  if (packFrame) {
    frame.pack();
  }
  else {
    frame.validate();
  }

  // Center the window
  Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
  Dimension frameSize = frame.getSize();
  if (frameSize.height > screenSize.height) {
    frameSize.height = screenSize.height;
    }
  if (frameSize.width > screenSize.width) {
    frameSize.width = screenSize.width;
    }
  frame.setLocation( (screenSize.width - frameSize.width) / 2,
                    (screenSize.height - frameSize.height) / 2);
  frame.setVisible(true);
  }

  /**
   * Application entry point.
   *
   * @param args String[]
   */
  public static void main(String[] args) {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        try {
          UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (Exception exception) {
          exception.printStackTrace();
        }

        new OptionPannels();
      }
    });
  }
}
